type t

type address = (Unix.inet_addr * int)

type server = { server_addr : (Unix.inet_addr * int); (* server address and port *)
		server_version : int;	(* which release is the server running *)
		server_name : string;	(* server name *)
		server_message : string; (* server message *)
		server_players : int;	(* how many players are on *)
		server_map_dims : int * int; (* map dimensions *)
		server_starttime : float;	(* when did the server start *)
	      }

type update = { update_interval : int;	(* you are expected to refresh the information every n seconds *)
	      }

(* set up a metaserver client *) 
val create : string -> t

(* retrieve a list of servers available *)
val list_servers : t -> server list

(* update server info *)
val update_server : t -> server -> update

(* remove registration info *)
val unregister_server : t -> server -> unit
