type t = unit

type address = (Unix.inet_addr * int)

type server = { server_addr : address;	(* server address and port *)
		server_version : int;	(* which release is the server running *)
		server_name : string;	(* server name *)
		server_message : string; (* server message *)
		server_players : int;	(* how many players are on *)
		server_map_dims : int * int; (* map dimensions *)
		server_starttime : float;	(* how many seconds has the server been up *)
	      }

type update = { update_interval : int;	(* you are expected to refresh the information every n seconds *)
	      }

(* set up a metaserver client *) 
let create : string -> t = 
  fun _url -> ()

(* retrieve a list of servers available *)
let list_servers : t -> server list =
  fun () -> []
	
(* update server info *)
let update_server : t -> server -> update =
  fun () info ->
    { update_interval = 1000000 }

(* remove registration info *)
let unregister_server : t -> server -> unit =
  fun () info ->
    ()
    
